/*
  LinEAK - Linux support for Easy Access and Internet Keyboards      
  Copyright (C) 2001,2002 Mark Smulders <Mark@PIRnet.nl>
  
  lineakconfig, GTK+ interface for configuring lineakd

  This program is free software; you can redistribute it and/or modify  
  it under the terms of the GNU General Public License as published by  
  the Free Software Foundation; either version 2, or (at your option)   
  any later version.                                                    
                                                                        
  This program is distributed in the hope that it will be useful,       
  but WITHOUT ANY WARRANTY; without even the implied warranty of        
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
  GNU General Public License for more details.                          
                                                                        
  You should have received a copy of the GNU General Public License     
  along with this program; if not, write to the                         
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,          
  Boston, MA 02111-1307, USA.                                           
*/

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/XKBlib.h>
#include <X11/extensions/XKBfile.h>

/**********************************************************************************************/

/* Standard gettext macros. */
#ifdef ENABLE_NLS
#  include <libintl.h>
#  undef _
#  define _(String) dgettext (PACKAGE, String)
#  ifdef gettext_noop
#    define N_(String) gettext_noop (String)
#  else
#    define N_(String) (String)
#  endif
#else
#  define textdomain(String) (String)
#  define gettext(String) (String)
#  define dgettext(Domain,Message) (Message)
#  define dcgettext(Domain,Message,Type) (Message)
#  define bindtextdomain(Domain,Directory) (Domain)
#  define _(String) (String)
#  define N_(String) (String)
#endif

/**********************************************************************************************/

/* EAKey as member of list */
typedef struct strEAkey {
  struct strEAkey *next;
  char *EAkeyname;
  int EAkeycode;
  KeySym EAkeysym;
  char *EAcommand;
} EAkey;

/* the EAK we will use.. */
typedef struct {
  int EAKnr;
  char *EAKtype;
  char *EAKname;
  EAkey *EAKeylist;
} EAKeyboard;
EAKeyboard myEAK;

/* function prototypes */
gint parseconffile(void);
gint parsedeffile(void);
gint initEAK (void);
void cleanKeylist (void);
gint cleanexit(void);
gint refreshGUIdata(GtkWidget *widget);
gint refresh_kbtypes (GtkWidget *widget);
gint refresh_cdromdev (GtkWidget *widget);
gint refresh_kbimage (GtkWidget *widget);
gint refresh_keylist (GtkWidget *widget);
gint refresh_keycommand (GtkWidget *widget, gint keyindex);
gint refresh_specials (GtkWidget *widget);
void select_new_keyboard(GtkWidget *widget, gpointer data);
void change_key_command(EAkey *thiskey, gchar *entrytext) ;
void change_selectedkey_command(gchar *entrytext);
gboolean backup_conffile (void);
gboolean restore_conffile (void);
gboolean save_conffile (void);
gboolean get_lineakd_pid(void);

char *kbtype, *cdromdev;
gint selected_key;

/*
 * This function returns a widget in a component created by Glade.
 * Call it with the toplevel widget in the component (i.e. a window/dialog),
 * or alternatively any widget in the component, and the name of the widget
 * you want returned.
 */
GtkWidget*  lookup_widget (GtkWidget *widget, const gchar *widget_name);

/* get_widget() is deprecated. Use lookup_widget instead. */
#define get_widget lookup_widget

/* pixmap related */
GtkWidget* create_my_pixmap (GtkWidget *widget, char **thepixmap);
gchar *check_file_exists (const gchar *directory, const gchar *filename);
GtkWidget *create_my_pixmap_from_file (GtkWidget *widget, const gchar *filename);
void replace_my_pixmap_from_file (GtkWidget *widget, GtkWidget *thepixmap, const gchar *filename);

/**********************************************************************************************/
